/*
Program: evalExpression-v2.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: XѽdinfixTopostfix.c{PĤTDĥ|DnDAϱo{iϥΪ
		qLJǪܦrAHYܹǪܦAA̦iBܵGȡC 
		PevalExpression-v1.c\ۦPAߤ@tbevaluate()ƪ@覡FHstrtok()
		@rRAHťէ@jrAXһݪB⤸PBlC 
Notes:
	10+20*(50-30)/2^4-6*8
	10+20*(-50+30)/-2^4-6*8
	10.5+20.8*(50.1-30.6)/2.5^4-6.6*8.2
	10.5+20.8*(-50.1+30.6)/2.5^-4-6.6*8.2
	10-30*(+50-20)/-2^-4+7.5*-6
	10+30*(+50.2+3.8)/+2^2.5+15*-6.5 
*/

#include <stdio.h>
#include <string.h>	/* for strtok() */
#include <math.h>	/* for pow() */
#include <ctype.h>	/* for isdigit() */

#define MAX 120

void infix_to_postfix(char [], int, char []);  /* ѤǨ */
int compare(char, char);	/* ӹBl */
float evaluate(char []);	/* sqơAǦ@һݪƾǹBæ^ǵG */ 

/* bǪܪkCμȦs|ABluǪAuȬINDEX/2 */
char infix_priority[9] = {'#', ')', '+', '-', '*', '/', '^', '('};
char stack_priority[8] = {'#', '(', '+', '-', '*', '/', '^'};

int main()
{
    int i, index = -1;
    char infix_q[MAX], postExpr[2*MAX] = {0};  /* xsϥΪ̿JǦrAഫǦrspostExpr */ 
    
	printf("\nпJǪܦ(䴩+-*/^()B) => ");
    
	while (infix_q[index] != '\n')
        infix_q[++index] = getchar();
    infix_q[index] = '#';  /* J̫@ӦrN'#'A@B⦡r굲 */
    
    printf("\nǪܦG");
    infix_to_postfix(infix_q,index,postExpr);
	//printf("\n --> %s\n",postExpr);
	printf("\n\nB⵲G=%g",evaluate(postExpr));
	//printf("\t(T=%g)\n\n",10+20*(50-30)/pow(2,4)-6*8);
	//printf("\t(T=%g)\n\n",10+20*(-50+30)/pow(-2,4)-6*8);
	printf("\t(T=%g)\n\n",10.5+20.8*(50.1-30.6)/pow(2.5,4)-6.6*8.2);
	//printf("\t(T=%g)\n\n",10.5+20.8*(-50.1+30.6)/pow(2.5,-4)-6.6*8.2);
	//printf("\t(T=%g)\n\n",10-30*(+50-20)/pow(-2,-4)+7.5*-6);
	//printf("\t(T=%g)\n\n",10+30*(+50.2+3.8)/pow(2,2.5)+15*-6.5);
	
    return 0;
}

void infix_to_postfix(char infix_q[], int index, char postExpr[])
{
    int top = 0, ctr, tag = 1, i = 0;
    char c, stack_t[MAX]; 	/* xs٤XBl */
    
	stack_t[top] = '#'; 	/* |̩U[J#Ÿ */
    for (ctr = 0; ctr <= index; ctr++) {	/* B⦡rAq0r}lAvryA̫ܳ@Ӧr */
        switch (infix_q[ctr]) {	/* ˵ctrޭȹreAdݬO_kXU@p */
            case ')':	/* J')'ANX|BlAuX'(' */ 
            	printf(" ");	/* ùܥ[Jťնj */
				sprintf(postExpr,"%s ",postExpr);
                while (stack_t[top] != '(') {
                	printf("%c ",c=stack_t[top--]);
                	sprintf(postExpr,"%s%c ",postExpr,c);
				}
                top--;	/* '('@ֲ */
                break;
            
            case '#':	/* J#ANwy̥rAO||XBlqquX */
            	printf(" ");
            	sprintf(postExpr,"%s ",postExpr); /* ɤJťթǦr */ 
                while (stack_t[top] != '#') {
                	printf("%c ",c=stack_t[top--]);
                	sprintf(postExpr,"%s%c ",postExpr,c);
				}
                break;
                
            case '(':
            case '^':
            case '*':
            case '/':
            	printf(" ");
            	sprintf(postExpr,"%s ",postExpr);
                while (compare(stack_t[top],infix_q[ctr])) {
                	printf("%c ",c=stack_t[top--]);
                	sprintf(postExpr,"%s%c ",postExpr,c);
				}
                stack_t[++top] = infix_q[ctr];
                tag = 1;
                break;
            case '+':
            case '-':
                if (tag == 1) { /* P_ '(' '^' '*' '/' ᪺ +- O_ܥt@Bl */
                    stack_t[++top] = infix_q[ctr];
                    tag = 2;  
                }
                else {
                	printf(" ");
                	sprintf(postExpr,"%s ",postExpr);
                    while (compare(stack_t[top],infix_q[ctr])) {
                        printf("%c ",c=stack_t[top--]);
                        sprintf(postExpr,"%s%c ",postExpr,c);
					}                        
                    stack_t[++top] = infix_q[ctr];
                    tag = 1;
                }
                break;
            
            case ' ': 
            	break; /* do nothingAL */ 
            /* JB⤸AhX */
            default:
                for (i = 0; isdigit(infix_q[ctr+i]) || infix_q[ctr+i]=='.'; i++) {
                	printf("%c",c=infix_q[ctr+i]);
                	sprintf(postExpr,"%s%c",postExpr,c);
				} 
				ctr += (i-1);
                if (tag == 2) {	/* Nsb|tX */
					printf(" %c ",c=stack_t[top--]); /* PuX|ݪ */  
                    sprintf(postExpr,"%s %c ",postExpr,c=='-'?'_':'@');
            	}
                tag = 0;
                break;
        }
    }
}

/* BluvAYJBlp󵥩|BlAhǦ^Ȭ 1A_h 0 */
int compare(char stack_o, char infix_o)
{
    int index_s = 0, index_i = 0;
    while (stack_priority[index_s] != stack_o)
        index_s++;
    while (infix_priority[index_i] != infix_o)
        index_i++;
    return index_s/2 >= index_i/2 ? 1 : 0;
}

float evaluate(char expr[])
{
	char *token;
	float stack[MAX], a, b, c;
	int top = -1;
   
	token = strtok(expr," ");  /* oĤ@ӲŰO */ 
	while (token != NULL) { 	/* YšAh~Rr */ 
    	if (atof(token)!=0.0) 
    		stack[++top] = atof(token);
    	else {
    		b = stack[top--];
    		a = stack[top--];
    		switch(token[0]) {
    			case '+':
    				c = a+b;
    				break;
    			case '-':
    				c = a-b;
    				break;
    			case '@':
    				stack[++top] = a; /* hXƱ^|A]@B */ 
    				c = b;
    				break;
				case '_':
    				stack[++top] = a; /* hXƱ^|A]@B */
    				c = -b;
    				break;
    			case '*':
    				c = a*b;
    				break;
    			case '/':
    				c = (float)a/b;
    				break;
    			case '^':
    				c = (float)pow(a,b);
    				break;
			}
			stack[++top] = c;
		}
      	token = strtok(NULL," "); /* ܯSOgkAЦPǦh[dN */ 
   	}
   	
   	return stack[top];
}
