/*
Program: evalExpression-v1.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: XѽdinfixTopostfix.c{PĤTDĥ|DnDAϱo{iϥΪ
		qLJǪܦrAHYܹǪܦAAiBܵGȡC 
		Q@Dȵ{ǡABlPB⤸[JŮj}ABǦùܻPrꤺ
		ܤGӪAG̴XGۦPA+-Ÿ@@Blγ~ɡArꤺNOH@_
		Ap]pNUq|uX@ӹB⤸μuXGӹB⤸iB
Notes: թҥοJiG 
	10+20*(50-30)/2^4-6*8
	10+20*(-50+30)/-2^4-6*8
	10.5+20.8*(50.1-30.6)/2.5^4-6.6*8.2
	10.5+20.8*(-50.1+30.6)/2.5^-4-6.6*8.2
	10-30*(+50-20)/-2^-4+7.5*-6
	10+30*(+50.2+3.8)/+2^2.5+15*-6.5 
	1+(3*(50.2-3.8)/2^2.5)/12+15*6.5
	1+(3*(-50.2+3.8)*2^-2.5)/12+15*-6.5
*/

#include <stdio.h>	/* for scanf(), printf(), sscanf(), sprintf() */
#include <math.h>	/* for pow() */
#include <ctype.h>	/* for isdigit() */

#define MAX 120

void infix_to_postfix(char [], int, char []);  /* ѤǦ */
int compare(char, char);	/* ӹBl */
float evaluate(char []);	/* sqơAǦ@һݪƾǹBæ^ǵG */ 

/* bǪܪkCμȦs|ABluǪAuȬINDEX/2 */
char infix_priority[9] = {'#', ')', '+', '-', '*', '/', '^', '('};
char stack_priority[8] = {'#', '(', '+', '-', '*', '/', '^'};

int main()
{
    int i, index = -1;
    char infix_q[MAX], postExpr[2*MAX] = {0}; 	/* xsϥΪ̿JǦrAഫǦrspostExpr */ 
    
	printf("\nпJǪܦ(䴩+-*/^()B) => ");
    
	while (infix_q[index] != '\n')
        infix_q[++index] = getchar();
    infix_q[index] = '#';  /* J̫@ӦrN'#'A@B⦡r굲 */
    
    printf("\nǪܦG");
    infix_to_postfix(infix_q,index,postExpr);	/* ǦǦơAഫGspostExpr */ 
	printf("\nҥΪǦG%s",postExpr);	/* postExprXA˵ĪGt */ 
	printf("\n\nB⵲G=%g",evaluate(postExpr));
	printf("\t(T=%g)\n\n",10+20*(50-30)/pow(2,4)-6*8);
	printf("\t(T=%g)\n\n",10+20*(-50+30)/pow(-2,4)-6*8);
	//printf("\t(T=%g)\n\n",10.5+20.8*(50.1-30.6)/pow(2.5,4)-6.6*8.2);
	//printf("\t(T=%g)\n\n",10.5+20.8*(-50.1+30.6)/pow(2.5,-4)-6.6*8.2);
	//printf("\t(T=%g)\n\n",10-30*(+50-20)/pow(-2,-4)+7.5*-6);
	//printf("\t(T=%g)\n\n",10+30*(+50.2+3.8)/pow(2,2.5)+15*-6.5);
	//printf("\t(T=%g)\n\n",1+(3*(50.2-3.8)/pow(2,2.5))/12+15*6.5);
	//printf("\t(T=%g)\n\n",1+(3*(-50.2+3.8)*pow(2,-2.5))/12+15*-6.5);
	
    return 0;
}

void infix_to_postfix(char infix_q[], int index, char postExpr[])	/* ǦǦơAഫGspostExprr */
{
    int top = 0, ctr, tag = 1, i = 0;
    char c, stack_t[MAX]; 	/* xs٤XBl */
    
	stack_t[top] = '#'; 	/* |̩U[J#Ÿ */
    for (ctr = 0; ctr <= index; ctr++) {	/* B⦡rAq0r}lAvryA̫ܳ@Ӧr */
        switch (infix_q[ctr]) {	/* ˵ctrޭȹreAdݬO_kXU@p */
            case ')':	/* J')'ANX|BlAuX'(' */ 
            	printf(" ");						/* ùܥ[Jťնj */
				sprintf(postExpr,"%s ",postExpr);	/* {postExprݥ[@ť */
                while (stack_t[top] != '(') {
                	printf("%c ",c=stack_t[top--]);	/* uX|ݪBlAsJcܩù */ 
                	sprintf(postExpr,"%s%c ",postExpr,c);	/* c[JpostExprå[@ť */ 
				}
                top--;	/* '('@ֲ */
                break;
            
            case '#':	/* J#ANwy̥rAO||XBlqquX */
            	printf(" ");						/* ùܥ[Jťնj */
            	sprintf(postExpr,"%s ",postExpr); 	/* postExprǦrA[@ť */ 
                while (stack_t[top] != '#') {
                	printf("%c ",c=stack_t[top--]);	/* j餺oGO޿PW73B74ۦP */ 
                	sprintf(postExpr,"%s%c ",postExpr,c);
				}
                break;
            
			/* JBlAYuv<=|ݪBluvAh|B
               lXAX|BlpJBluvF
               Yy쪺Bl>|ݪBlAhJBlJ| */   
            case '(':
            case '^':
            case '*':
            case '/':
            	printf(" ");
            	sprintf(postExpr,"%s ",postExpr);
                while (compare(stack_t[top],infix_q[ctr])) { /* |uvjBlqquX */
                	printf("%c ",c=stack_t[top--]);	/* j餺oGO޿PW73B74ۦP */
                	sprintf(postExpr,"%s%c ",postExpr,c);
				}
                stack_t[++top] = infix_q[ctr];	/* sy쪺BlJ| */
                tag = 1;
                break;
            case '+':
            case '-':
                if (tag == 1) { /* P_ '(' '^' '*' '/' ᪺ +- O_@@Blγ~ */
                    stack_t[++top] = infix_q[ctr];	/* Y@Blγ~A+-J| */
                    tag = 2; 	/* tag]2AХܬSpANϱo򱵵۪B⤸XAHY+-uX */
                }
                else {	/* untag1Ahi@몺Bz覡C]+-B⪺uvCAG|uvBluX */
                	printf(" ");
                	sprintf(postExpr,"%s ",postExpr);
                    while (compare(stack_t[top],infix_q[ctr])) {
                        printf("%c ",c=stack_t[top--]);	/* j餺oGO޿PW73B74ۦP */
                        sprintf(postExpr,"%s%c ",postExpr,c);
					}                        
                    stack_t[++top] = infix_q[ctr];
                    tag = 1;
                }
                break;
            
            case ' ':	/* JǦrYŮAhLӦr */ 
            	break; 	/* do nothingAL */ 
            
            default:	/* JrPHWpšAhB⤸AiX */
                for (i = 0; isdigit(infix_q[ctr+i]) || infix_q[ctr+i]=='.'; i++) { /* j^s򪺦r@B⤸AiOƩαapIBI */ 
                	printf("%c",c=infix_q[ctr+i]);		/* Hctr}lmA+iMwU@ӸŪrmAӦrŪXsJcܩù */
                	sprintf(postExpr,"%s%c",postExpr,c);/* c[JpostExprA`N[ťնj */
				} 
				ctr += (i-1);	/* B⤸wBzAվctrܹB⤸᪺U@Ӧrm */ 
                if (tag == 2) {	/* tag]2AN+-Bl@γ~AOsb|+-ŸX */
					printf(" %c ",c=stack_t[top--]); 	/* uX|ݪAscܩù */  
                    sprintf(postExpr,"%s %c ",postExpr,c=='-'?'_':'@');	/* o̭AF˵cO_-AYOAh]'_'postExprݡA_h'@']JǦ */ 
            	}
                tag = 0;		/* @XLB⤸AtagYk0AѰ+-@BlA */ 
                break;
        }
    }
}

/* BluvAYJBlp󵥩|BlAhǦ^Ȭ 1A_h 0 */
int compare(char stack_o, char infix_o)
{
    int index_s = 0, index_i = 0;
    while (stack_priority[index_s] != stack_o)
        index_s++;
    while (infix_priority[index_i] != infix_o)
        index_i++;
    return index_s/2 >= index_i/2 ? 1 : 0;
}

float evaluate(char *str)	/* ̿JǦrAiBD */ 
{
	char token[16]; 
	float stack[MAX], operand, a, b, t;	/* stack[]t@Ӱ|ADȹBL{ȦsB⤸ */ 
	int top = -1;
	
	for (; *str; str++) {	/* Hjv@˵strҦrAunثe˵r'\0'Ah橳Uʧ@ */ 
		if (*str == ' ')	/* YťզrAhL */ 
			continue;
		else if (isdigit(*str)) {	/* YU˵rƦrAN򱵳sXӦr@ӹB⤸ */
			sscanf(str,"%f%1000[^\n]",&operand,str);	/* FŪ㪺B⤸AHIƪ榡ŪJoperandAѾlrA]str */
			stack[++top] = operand;						/* B⤸operandJ| */ 
		}
		else {	/* U˵rBl */
			b = stack[top--];	/* stackuXA̷sJB⤸ */ 
    		a = stack[top--];	/* stackuXAsB⤸ */
    		switch (*str) {		/* ˵UrN@عB  */ 
    			case '+':
    				t = a+b;	/* [kB⵲G]t */ 
    				break;
    			case '-':
    				t = a-b;	/* kB⵲G]t */
    				break;
    			case '@':		
    				stack[++top] = a; /* hXƱ^|A]@BA`Na(ӫDb)^| */ 
    				t = b;
    				break;
				case '_':
    				stack[++top] = a; /* hXƱ^|A]@B */
    				t = -b;	/* negate b */ 
    				break;
    			case '*':
    				t = a*b;				/* kB⵲G]t */
    				break;
    			case '/':
    				t = (float)a/b;			/* kB⵲G]t */
    				break;
    			case '^':
    				t = (float)pow(a,b);	/* ƹB⵲G]t */
    				break;
			}
			stack[++top] = t;	/* so쪺tȱJ| */ 
		}
	}
   	
   	return stack[top];	/* ӵ{ǧA|ݫOB̲׵G */ 
}
